package cat.hack3.codingtests.marsrover;

public class Coordinates {
    private final int latitude;
    private final int longitude;

    public static Coordinates of(int latitude, int longitude) {
        return new Coordinates(latitude, longitude);
    }

    public Coordinates ofUpdatedLatitude(int newLatitude) {
        return new Coordinates(newLatitude, longitude);
    }

    public Coordinates ofUpdatedLongitude(int newLongitude) {
        return new Coordinates(latitude, newLongitude);
    }

    private Coordinates(int latitude, int longitude) {
        this.latitude = latitude;
        this.longitude = longitude;
    }

    public int getLatitude() {
        return latitude;
    }

    public int getLongitude() {
        return longitude;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Coordinates that = (Coordinates) o;

        if (latitude != that.latitude) return false;
        return longitude == that.longitude;
    }

    @Override
    public String toString() {
        return "Coordinates{" +
                "latitude=" + latitude +
                ", longitude=" + longitude +
                '}';
    }

}
